/*
 *  Sample C.    Lexical analysis
 */

%{
  #include "symbol.c"
%}

/*
 *  Regular  Definitions
 */

%%

/*
 *  Translations Rules
 */

%%

/*
 *  functions
 */


static struct rwtable        /* reserved word table */
{
  char * name;               /* representation */
  int  token;                /* yylex() value  */
} reservedWords[];           /* sorted */


/*
 *  binary search
 */
static int binary()
{
} /* binary */

/*
 *  main function of PRCT 1
 */

main( int argc, char ** argv )
{

  int tok = 0;
  FILE *file;

  if (argc > 1)
  {
    file = fopen( argv[1], "r");
    if ( !file )
    {
      fprintf(stderr, "could not open %s\n", argv[1] );
      exit(1);
    }
    yyin = file;
  } /* if */

  /* ???????????? */      /* table symbol initialize */

  while ( (tok = yylex()) != 0 )
  {
    switch ( tok )
    {
      case CONST    : printf( "%d: CONST %d\n", yylineno, yylval.value );
                      break;
      case ID       : printf( "%d: ID %s\n", yylineno, yylval.ptr->name);
                      break;
      case IF       : printf( "%d: IF\n", yylineno);
                      break;
      case INT      : printf( "%d: INT\n", yylineno);
                      break;
      case ELSE     : printf( "%d: ELSE\n", yylineno);
                      break;
      case WHILE    : printf( "%d: WHILE\n", yylineno);
                      break;
      case BREAK    : printf( "%d: BREAK\n", yylineno);
                      break;
      case CONTINUE : printf( "%d: CONTINUE\n", yylineno);
                      break;
      case RETURN   : printf( "%d: RETURN\n", yylineno);
                      break;
      case GE       : /* >= */
                      printf( "%d: >=\n", yylineno);
                      break;
      case LE       : /* <= */
                      printf( "%d: <=\n", yylineno);
                      break;
      case EQ       : /* == */
                      printf( "%d: ==\n", yylineno);
                      break;
      case NE       : /* != */
                      printf( "%d: !=\n", yylineno);
                      break;
      case PE       : /* += */
                      printf( "%d: +=\n", yylineno);
                      break;
      case ME       : /* -= */
                      printf( "%d: -=\n", yylineno);
                      break;
      case TE       : /* *= */
                      printf( "%d: *=\n", yylineno);
                      break;
      case DE       : /* /= */
                      printf( "%d: /=\n", yylineno);
                      break;
      case RE       : /* %= */
                      printf( "%d: %=\n", yylineno);
                      break;
      case PP       : /* ++ */
                      printf( "%d: ++\n", yylineno);
                      break;
      case MM       : /* -- */
                      printf( "%d: --\n", yylineno);
                      break;
      case ';'      :      case '('      :      case ')'      :
      case '{'      :      case '}'      :      case '+'      :
      case '-'      :      case '*'      :      case '/'      :
      case '%'      :      case '<'      :      case '>'      :
      case '&'      :      case '^'      :      case '|'      :
      case '='      :
      case ','      : printf( "%d: %c\n", yylineno, tok);
                      break;
      default       : printf( "%d: Unkown Character %c\n", yylineno, tok );
                      break;
    }; /* switch */
  } /*while */;
} /* main */

